/* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
/* If you are missing that file, acquire a complete release at teeworlds.com.                */

/*>======================<*/
/*			  */
/*===TeeKing mod by the===*/
/*			  */
/*>======================<*/

#include "teeking.h"
#include <engine/shared/config.h>

#include <game/server/player.h>

#include <game/server/gamecontext.h>
#include <game/server/entities/character.h>

#include <game/generated/protocol.h>
#include <string.h>

CGameControllerTEEKING::CGameControllerTEEKING(class CGameContext *pGameServer)
: IGameController(pGameServer)
{
	dbg_msg("server", "TEEKING constructor called.");
	// Exchange this to a string that identifies your game mode.
	// DM, TDM and CTF are reserved for teeworlds original modes.
	m_pGameType = "TeeKing";
	king_resp = 0;
	//m_GameFlags = GAMEFLAG_TEAMS; // GAMEFLAG_TEAMS makes it a two-team gamemode
}

void CGameControllerTEEKING::Tick()
{
	int king_counter = 0;
	// this is the main part of the gamemode, this function is run every tick
	IGameController::Tick();
	for(int i=0; i < MAX_CLIENTS; i++)
	{
		if(!GameServer()->m_apPlayers[i])
			continue;
		if(GameServer()->m_apPlayers[i]->GetTeam() == TEAM_SPECTATORS)
			GameServer()->m_apPlayers[i]->king = 0;
		if(GameServer()->m_apPlayers[i]->king != 0)
			king_counter++;
	}
	if( ( king_counter < g_Config.m_SvKingNumber ) || ( g_Config.m_SvKingNumber == 0 && king_counter == 0) || (g_Config.m_SvKingNumber == -1) )
		{
			if(king_resp == 0)
			{
				for(int i=0; i < MAX_CLIENTS; i++)
				{			
					if(!GameServer()->m_apPlayers[i])
						continue;
					if(GameServer()->m_apPlayers[i]->king == 0)
					{
						GameServer()->m_apPlayers[i]->king = rand()%256+1;
						GameServer()->SendBroadcast("The TeeWorld needs a king, mb you can?", -1);
					}
					if(GameServer()->m_apPlayers[i]->GetTeam() == TEAM_SPECTATORS)
						GameServer()->m_apPlayers[i]->king = 0;
				}
				king_resp = 300;
			}
			else king_resp--;
		}
	return;
}

void CGameControllerTEEKING::PostReset()
{
	IGameController::PostReset();

	dbg_msg("server", "TEEKING PostReset");
	for(int i = 0; i < MAX_CLIENTS; i++)
	{
		if(GameServer()->m_apPlayers[i])
		{
			GameServer()->m_apPlayers[i]->king = 0;
			GameServer()->m_apPlayers[i]->king_imm_count = 0;
		}
	}
}
